Loading...
Searching...
No Matches
casacore::ConstantND< T > Class Template Reference
scimath package (libcasa_scimath) » Functionals_module

More...

`#include <ConstantND.h>`

## Public Member Functions

| ConstantND (const uInt m=0)
| Construct a constant in an a space of dimensionality m.
| ConstantND (const ConstantND< T > &other)
| Copy constructor/assignment (deep copy).
template<class W>
| ConstantND (const ConstantND< W > &other)
ConstantND< T > & | operator= (const ConstantND< T > &other)
virtual | ~ConstantND ()
| Destructor.
virtual T | eval (typename Function< T >::FunctionArg x) const
| Evaluate the hyper plane function at (x0,x1,..,xm-1).
virtual Function< T > * | clone () const
| Return a copy of this object from the heap.
virtual Function< typename FunctionTraits< T >::DiffType > * | cloneAD () const
virtual Function< typename FunctionTraits< T >::BaseType > * | cloneNonAD () const
Public Member Functions inherited from casacore::ConstantNDParam< T >
| ConstantNDParam (uInt m=0)
| Construct a constant in m-dimensional space.
| ConstantNDParam (const ConstantNDParam &other)
| Copy constructor (deep copy).
template<class W>
| ConstantNDParam (const ConstantNDParam< W > &other)
ConstantNDParam< T > & | operator= (const ConstantNDParam< T > &other)
| Copy assignment (deep copy).
virtual | ~ConstantNDParam ()
| Destructor.
Bool | operator== (const ConstantNDParam< T > &other) const
| Comparisons.
Bool | operator!= (const ConstantNDParam< T > &other) const
virtual const String & | name () const
| Give name of function.
virtual uInt | ndim () const
| What is the dimension of the parameter list.
Public Member Functions inherited from casacore::Function< T, U >
| Function ()
| Constructors.
| Function (const uInt n)
| Function (const Vector< T > &in)
| Function (const FunctionParam< T > &other)
template<class W, class X>
| Function (const Function< W, X > &other)
virtual | ~Function ()
| Destructor.
uInt | nparameters () const
| Returns the number of parameters.
virtual U | eval (FunctionArg x) const =0
| Evaluate the function object.
T & | operator[] (const uInt n)
| Manipulate the nth parameter (0-based) with no index check.
const T & | operator[] (const uInt n) const
virtual U | operator() () const
| Evaluate this function object at xor at x, y.
virtual U | operator() (const ArgType &x) const
virtual U | operator() (const Vector< ArgType > &x) const
virtual U | operator() (FunctionArg x) const
virtual U | operator() (const ArgType &x, const ArgType &y) const
virtual U | operator() (const ArgType &x, const ArgType &y, const ArgType &z) const
Bool & | mask (const uInt n)
| Manipulate the mask associated with the nth parameter (e.g.
const Bool & | mask (const uInt n) const
const FunctionParam< T > & | parameters () const
| Return the parameter interface.
FunctionParam< T > & | parameters ()
const Vector< ArgType > & | argp () const
| Get arg_p and parset_p.
Bool | parsetp () const
void | lockParam ()
| Compiler cannot always find the correct 'const' version of parameter access.
void | unlockParam ()
virtual void | setMode (const RecordInterface &mode)
| get/set the function mode.
virtual void | getMode (RecordInterface &mode) const
virtual Bool | hasMode () const
| return True if the implementing function supports a mode.
ostream & | print (ostream &os) const
| Print the function (i.e.
Public Member Functions inherited from casacore::Functional< FunctionTraits< T >::ArgType, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const FunctionTraits< T >::ArgType &x) const=0
| Map a Domain x into a Range y value.
Public Member Functions inherited from casacore::Functional< Vector< FunctionTraits< T >::ArgType >, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const Vector< FunctionTraits< T >::ArgType > &x) const=0
| Map a Domain x into a Range y value.

## Additional Inherited Members

Public Types inherited from casacore::Function< T, U >
typedef FunctionTraits< T >::ArgType | ArgType
typedef const ArgType * | FunctionArg
Protected Attributes inherited from casacore::Function< T, U >
FunctionParam< T > | param_p
| The parameters and masks.
Vector< ArgType > | arg_p
| Aid for non-contiguous argument storage.
Bool | parset_p
| Indicate parameter written.
Bool | locked_p
| Indicate that parameters are expected to be locked from changing.

## Detailed Description

template<class T>
class casacore::ConstantND< T >

A constant function.

### Intended use:

Public interface

### Review Status

Test programs:
  tConstant

### Prerequisite

- Function

### Synopsis

This class represents a constant function in a space of arbitrary dimension f(x0,x1,..,xm-1) = constant where xi are independent arguments and m is the number of dimensions of the space.

Since the Constant is a Function, the derivatives can be obtained as well (and are in fact 0 of course).

The parameter interface (see FunctionParam class), is used to provide an interface to the Fitting classes.

This class is in general used implicitly by the Constant class only.

### Example

// form the constant function in 4-D space
Constant<Double> constant(4); // 4-dim hyperplane
constant.parameters()[0] = 22;
// Evaluate at x0=5, x3=7
Vector<Double> x(4);
x=0; x[0]=5; x[3]=7;
cout << "constant value: " << constant(x) << endl;
constant value: 22
casacore::Vector
Definition Vector.h:82
casacore::value
NewDelAllocator< T > NewDelAllocator< T >::value
Definition Allocator.h:368

### Template Type Argument Requirements (T)

- T should have standard numerical operators. Current implementation only tested for real types (and their AutoDiffs).

### Thrown Exceptions

- Assertion in debug mode if attempt is made to address incorrect coefficients

### Motivation

This class was created because HyperPlane does not support a constant offset and modifying that class really required an interface change (ie that the constant offset be at the beginning of the parameter vector and that the parameter vector increase by one) so rather than breaking any code that already used HyperPlane I simply made a trivial Constant class.

### To Do

- Nothing I know of

Definition at line 105 of file ConstantND.h.

## Constructor & Destructor Documentation

## ConstantND() [1/3]

template<class T>

casacore::ConstantND< T >::ConstantND | ( | const uInt | m = 0 | ) |

inline explicit

Construct a constant in an a space of dimensionality m.

By default, the constant value is initialised to zero, and m=0

Definition at line 111 of file ConstantND.h.

References casacore::ConstantNDParam< T >::ConstantNDParam().

Referenced by clone(), cloneAD(), cloneNonAD(), ConstantND(), ConstantND(), and operator=().

## ConstantND() [2/3]

template<class T>

casacore::ConstantND< T >::ConstantND | ( | const ConstantND< T > & | other | ) |

inline

Copy constructor/assignment (deep copy).

Definition at line 114 of file ConstantND.h.

References ConstantND(), and casacore::ConstantNDParam< T >::ConstantNDParam().

## ConstantND() [3/3]

template<class T>
template<class W>

casacore::ConstantND< T >::ConstantND | ( | const ConstantND< W > & | other | ) |

inline

Definition at line 116 of file ConstantND.h.

References ConstantND(), and casacore::ConstantNDParam< T >::ConstantNDParam().

## ~ConstantND()

template<class T>

virtual casacore::ConstantND< T >::~ConstantND | ( |  | ) |

inline virtual

Destructor.

Definition at line 122 of file ConstantND.h.

## Member Function Documentation

## clone()

template<class T>

virtual Function< T > * casacore::ConstantND< T >::clone | ( |  | ) | const

inline virtual

Return a copy of this object from the heap.

The caller is responsible for deleting the pointer.

Implements casacore::Function< T, U >.

Definition at line 132 of file ConstantND.h.

References ConstantND().

## cloneAD()

template<class T>

virtual Function< typename FunctionTraits< T >::DiffType > * casacore::ConstantND< T >::cloneAD | ( |  | ) | const

inline virtual

Reimplemented from casacore::Function< T, U >.

Definition at line 133 of file ConstantND.h.

References ConstantND().

## cloneNonAD()

template<class T>

virtual Function< typename FunctionTraits< T >::BaseType > * casacore::ConstantND< T >::cloneNonAD | ( |  | ) | const

inline virtual

Reimplemented from casacore::Function< T, U >.

Definition at line 135 of file ConstantND.h.

References ConstantND().

## eval()

template<class T>

virtual T casacore::ConstantND< T >::eval | ( | typename Function< T >::FunctionArg | x | ) | const

virtual

Evaluate the hyper plane function at (x0,x1,..,xm-1).

## operator=()

template<class T>

ConstantND< T > & casacore::ConstantND< T >::operator= | ( | const ConstantND< T > & | other | ) |

inline

Definition at line 117 of file ConstantND.h.

References ConstantND(), and casacore::ConstantNDParam< T >::operator=().

The documentation for this class was generated from the following file:

- scimath/Functionals/ConstantND.h